﻿using System;
using System.Text;
using ClownFish;
using System.Collections.Generic;
using Model;

namespace ManagerService
{
    /// <summary>
    /// 表[T_Student]的Model[Student]数据访问类
    /// </summary>
    /// <remarks>作者：</remarks>
    /// <remarks>日期：</remarks>
    public class StudentManagerService
    {
        #region SqlParameters
        ///// <summary>
        ///// 检查符合条件的对象是否存在
        ///// </summary>
        ///// <param name="student_id">学生编号</param>
        ///// <returns>存在为True，否则为False</returns>
        //public static bool Exists_Student(int student_id)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("select count(*)  ");
        //    sbSQL.Append(" from T_Student where Student_ID = @Student_ID  ");
        //    return DbHelper.ExecuteScalar(sbSQL.ToString(), new { Student_ID = student_id }, CommandKind.SqlTextWithParams) != null;
        //}

        ///// <summary>
        ///// 添加数据到数据库
        ///// </summary>
        ///// <param name="objModel">对象实体</param>
        ///// <returns>影响的行数</returns>
        //public static int Insert_Student(Student student)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("Insert into T_Student (");
        //    sbSQL.Append("Student_Name,Student_Age,Student_Gender,Student_Birth,Student_Remark");
        //    sbSQL.Append(") values (");
        //    sbSQL.Append("@Student_Name,@Student_Age,@Student_Gender,@Student_Birth,@Student_Remark)");
        //    return DbHelper.ExecuteNonQuery(sbSQL.ToString(), student, CommandKind.SqlTextWithParams);
        //}

        ///// <summary>
        ///// 更新数据到数据库
        ///// </summary>
        ///// <param name="objModel">对象实体</param>
        ///// <returns>影响的行数</returns>
        //public static int Update_Student(Student student)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("update T_Student set ");
        //    sbSQL.Append("Student_Name = @Student_Name,");
        //    sbSQL.Append("Student_Age = @Student_Age,");
        //    sbSQL.Append("Student_Gender = @Student_Gender,");
        //    sbSQL.Append("Student_Birth = @Student_Birth,");
        //    sbSQL.Append("Student_Remark = @Student_Remark");
        //    sbSQL.Append(" where Student_ID = @Student_ID  ");
        //    return DbHelper.ExecuteNonQuery(sbSQL.ToString(), student, CommandKind.SqlTextWithParams);
        //}

        ///// <summary>
        ///// 从数据库中删除数据
        ///// </summary>
        ///// <param name="student_id">学生编号</param>
        ///// <returns>影响的行数</returns>
        //public static int Delete_Student(int student_id)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("delete T_Student ");
        //    sbSQL.Append(" where Student_ID = @Student_ID  ");
        //    return DbHelper.ExecuteNonQuery(sbSQL.ToString(), new { Student_ID = student_id }, CommandKind.SqlTextWithParams);
        //}

        ///// <summary>
        ///// 根据用户参数返回对象
        ///// </summary>
        ///// <param name="student_id">学生编号</param>
        ///// <returns>对象实体</returns>
        //public static Student GetModel_Student(int student_id)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("select top 1 Student_ID,Student_Name,Student_Age,Student_Gender,Student_Birth,Student_Remark ");
        //    sbSQL.Append(" from T_Student where Student_ID = @Student_ID  ");
        //    return DbHelper.GetDataItem<Student>(sbSQL.ToString(), new { Student_ID = student_id }, CommandKind.SqlTextWithParams);
        //}

        ///// <summary>
        ///// 获取数据列表（通过条件语句组合的任意查询）
        ///// </summary>
        ///// <param name="sConditionExpression">查询条件语句，必须以 and 作为开头，可以是string.Empty</param>
        ///// <returns>对象实体列表</returns>
        //public static List<Student> GetList_Student(string sConditionExpression)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("select Student_ID,Student_Name,Student_Age,Student_Gender,Student_Birth,Student_Remark ");
        //    sbSQL.AppendFormat(" from T_Student where (1=1) {0} ", sConditionExpression);
        //    return DbHelper.FillList<Student>(sbSQL.ToString(), null, CommandKind.SqlTextNoParams);
        //}
        ///// <summary>
        ///// 获取数据列表（通过选择条件的参数化查询）
        ///// <param name="student_id">学生编号</param>
        ///// </summary>
        ///// <returns>对象实体列表</returns>
        //public static List<Student> GetList_Student(int student_id)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("select Student_ID,Student_Name,Student_Age,Student_Gender,Student_Birth,Student_Remark ");
        //    sbSQL.Append(" from T_Student where Student_ID = @Student_ID  ");
        //    return DbHelper.FillList<Student>(sbSQL.ToString(), new { Student_ID = student_id }, CommandKind.SqlTextWithParams);
        //}

        ///// <summary>
        ///// 获取分页数据列表
        ///// </summary>
        ///// <param name="Pageinfo_Student_DIY">分页对象</param>
        ///// <returns>分页对象实体列表</returns>
        //public static List<Student> GetListPage_Student(Pageinfo_Student_DIY pageinfo)
        //{
        //    StringBuilder sbSQL = new StringBuilder();
        //    sbSQL.Append("declare @ResultTable table (");
        //    sbSQL.Append("RowIndex int,");
        //    sbSQL.Append("Student_ID int,");
        //    sbSQL.Append("Student_Name varchar(20),");
        //    sbSQL.Append("Student_Age int,");
        //    sbSQL.Append("Student_Gender bit,");
        //    sbSQL.Append("Student_Birth date,");
        //    sbSQL.Append("Student_Remark varchar(50)");
        //    sbSQL.Append(");");

        //    sbSQL.Append("declare @SQLString	nvarchar(4000) = N'select row_number() over (order by Student_ID asc) as RowIndex,");
        //    sbSQL.Append(" o.Student_ID, o.Student_Name, o.Student_Age, o.Student_Gender, o.Student_Birth, o.Student_Remark");
        //    sbSQL.Append(" from [T_Student] as o where (1=1) '+ @ConditionExpression;");
        //    sbSQL.Append(" insert into @ResultTable exec sp_executesql @SQLString;");

        //    sbSQL.Append("select * from @ResultTable where RowIndex > (@PageSize * @PageIndex) and RowIndex <= (@PageSize * (@PageIndex + 1));");
        //    string sTotalSQL = string.Format("select count(*) from [T_Student] where (1=1) {0}", pageinfo.ConditionExpression);
        //    pageinfo.TotalRecords = DbHelper.ExecuteScalar<int>(sTotalSQL, pageinfo, CommandKind.SqlTextNoParams);
        //    return DbHelper.FillListPaged<Student>(sbSQL.ToString(), pageinfo, CommandKind.SqlTextWithParams);
        //}
        #endregion

        #region XmlCommand
        /// <summary>
		/// 检查符合条件的对象是否存在
		/// </summary>
		/// <param name="student_id">学生编号</param>
		/// <returns>存在为True，否则为False</returns>
		public static bool Exists_Student(int student_id)
		{
			return DbHelper.GetDataItem<Student>("ExistsStudent", new { Student_ID = student_id }) != null;
		}

		/// <summary>
		/// 添加数据到数据库
		/// </summary>
		/// <param name="objModel">对象实体</param>
		/// <returns>影响的行数</returns>
		public static int Insert_Student(Student objModel)
		{
			return DbHelper.ExecuteNonQuery("InsertStudent", objModel, CommandKind.SpOrXml);
		}

		/// <summary>
		/// 更新数据到数据库
		/// </summary>
		/// <param name="objModel">对象实体</param>
		/// <returns>影响的行数</returns>
		public static int Update_Student(Student objModel)
		{
			return DbHelper.ExecuteNonQuery("UpdatetStudent", objModel, CommandKind.SpOrXml);
		}

		/// <summary>
		/// 从数据库中删除数据
		/// </summary>
		/// <param name="student_id">学生编号</param>
		/// <returns>影响的行数</returns>
		public static int Delete_Student(int student_id)
		{
			return DbHelper.ExecuteNonQuery("DeleteStudent", new { Student_ID = student_id }, CommandKind.SpOrXml);
		}

		/// <summary>
		/// 根据用户参数返回对象
		/// </summary>
		/// <param name="student_id">学生编号</param>
		/// <returns>对象实体</returns>
		public static Student GetModel_Student(int student_id)
		{
			return DbHelper.GetDataItem<Student>("GetStudent", new { Student_ID = student_id });
		}

		/// <summary>
		/// 获取数据列表
		/// <param name="student_id">学生编号</param>
		/// </summary>
		/// <returns>对象实体列表</returns>
		public static List<Student> GetList_Student(int student_id)
		{
			return DbHelper.FillList<Student>("GetStudentList", new { Student_ID = student_id }, CommandKind.SpOrXml);
		}

		/// <summary>
		/// 获取分页数据列表
		/// </summary>
		/// <param name="Pageinfo_Student_DIY">分页对象</param>
		/// <returns>分页对象实体列表</returns>
		public static List<Student> GetListPage_Student(Pageinfo_Student_DIY pageinfo)
		{
            //此句是调用存储过程，代码一样，所以正常 
            //return DbHelper.FillListPaged<Student>("GetStudentListPageX", pageinfo, CommandKind.StoreProcedure);

            //此句是调用XmlCommand，不可以用，提示“指定的参数已超出有效值的范围。”
            return DbHelper.FillListPaged<Student>("GetStudentListPage", pageinfo, CommandKind.XmlCommand);
		}
        #endregion
    }

    /// <summary>
    /// 自定义分页对象(有条件的查询）
    /// </summary>
    public class Pageinfo_Student_DIY : PagingInfo
    {
        /// <summary>
        /// 查询条件字符串，通过前台条件拼接，非必输入项
        /// </summary>
        private string _conditionExpression = string.Empty;
        public string ConditionExpression { get { return _conditionExpression; } set { _conditionExpression = value; } }
        /// <summary>
        /// 学生编号
        /// </summary>
        public int Student_ID { get; set; }
    }
}
