﻿using System;
using CodeRoboter.Utility;     //需要引用生成器中提供的类库

namespace Model
{
    /// <summary>
    /// 表[T_Student]实体类:[Student]
    /// </summary>
    public class Student
    {
        public Student() { }
        private int _student_id;
        private string _student_name;
        private int _student_age;
        private bool _student_gender;
        private DateTime _student_birth;
        private string _student_remark;
        /// <summary>
        /// 学生编号
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "学生编号")]
        public int Student_ID
        {
            set { _student_id = value; }
            get { return _student_id; }
        }
        /// <summary>
        /// 学生名称
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "学生名称")]
        public string Student_Name
        {
            set { _student_name = value; }
            get { return _student_name; }
        }
        /// <summary>
        /// 年龄
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "年龄")]
        public int Student_Age
        {
            set { _student_age = value; }
            get { return _student_age; }
        }
        /// <summary>
        /// 性别
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "性别")]
        public bool Student_Gender
        {
            set { _student_gender = value; }
            get { return _student_gender; }
        }
        /// <summary>
        /// 出生日期
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "出生日期")]
        public DateTime Student_Birth
        {
            set { _student_birth = value; }
            get { return _student_birth; }
        }
        /// <summary>
        /// 备注
        /// </summary>
        [TableColumn_DIY_Attribute(ColumnNoteText = "备注")]
        public string Student_Remark
        {
            set { _student_remark = value; }
            get { return _student_remark; }
        }

    }
}
